--- === CONFIG ===

local Target_Prefixes = { "Cargo" } -- Add all the relevant target prefixes / suffixes to this table. (Just give a common prefix or suffix to any chosen targetable units in ME)

local AFAC_Name = "JTAC 1" -- This must be the unit name / PILOT name of your chosen AFAC/JTAC unit in ME

local Custom_LaserCode = 1688 -- Introduce a 4 digit number, 1688 is recommended. Note that Su25, Su25T and A10A clients will be given the code 1113 regardless (since it's the only one that works to some extent for them) 

local Maximum_Detection_Range = 20000 -- Introduce the desired maximum detection range of the AFAC unit (in meters)

local Lasing_Time = 10 -- Introduce the desired lasing time (in minutes)

--- ============== 
 
 
 env.info("Script loaded!")
 
 MESSAGE:New("Universal Buddy Lasing Script loaded!",10, nil, true):ToAll()
 
 _SETTINGS:SetPlayerMenuOff()
 
 if UNIT:FindByName(AFAC_Name) and UNIT:FindByName(AFAC_Name):IsAlive() == true then
 
    Lasing_AFAC = UNIT:FindByName(AFAC_Name) 
    
    MESSAGE:New("Active JTAC unit named "..AFAC_Name.." detected!!!",10, nil, true):ToAll()
 
 else
     
    MESSAGE:New("Unable to detect any active JTAC unit named "..AFAC_Name.."!!!\nBuddy lasing won't work!",10, nil, true):ToAll()
 
 end

 
 local function LaseAbort(Client_Group)
 
    Lasing_AFAC:LaseOff()
 
    MESSAGE:New("Current lasing task aborted!",10, nil, true):ToGroup(Client_Group)
 
     if TargetMenuRoot then
      TargetMenuRoot:Remove()
     end
     
     if StatusMenuRoot then
      StatusMenuRoot:Remove()
     end
  end 


 local function LaseCheck(Target, Client_Group)
 
  if Lasing_AFAC:IsAlive() == true then
  
   if Lasing_AFAC:IsLasing() == true then
   
    local Target_LLDDM_1 = Target:GetCoordinate():ToStringLLDDM()
    
    local Target_Range_Meters_1 = Client_Group:GetPointVec3():Get3DDistance(Target:GetCoordinate())
    local Target_Range_KM_1 = Target_Range_Meters_1 / 1000
    local Target_Range_KM_Rounded_1 = UTILS.Round(Target_Range_KM_1, 2)
   
    local Target_Range_NM_1 = Target_Range_Meters_1 / 1852
    local Target_Range_NM_Rounded_1 = UTILS.Round(Target_Range_NM_1, 2)
    
    local Target_Elevation_MSL_1_Meters = land.getHeight(Target:GetVec2())
    local Target_Elevation_MSL_1_Meters_Rounded_1 = UTILS.Round(Target_Elevation_MSL_1_Meters, 0)
    
    local Target_Elevation_MSL_Ft_1 = Target_Elevation_MSL_1_Meters_Rounded_1 * 3.281
    local Target_Elevation_MSL_Ft_Rounded_1 = UTILS.Round(Target_Elevation_MSL_Ft_1, 0)
   
    
    if Target:GetVelocityKMH() > 0 then
       
      IsMoving = "\n\nTarget is moving! (Marked with smoke)"
      
      Target:SmokeBlue()
      
    elseif Target:GetVelocityKMH() == 0 then
    
      IsMoving = "\n\nTarget isn't moving! (Marked with smoke)"
      
      Target:SmokeBlue()
    end
    
   
     if Client_Group:GetTypeName() == "Su-25T" then
        
        if Target:GetVelocityKMH() > 0 then 
    
           MESSAGE:New("You're flying a Su-25T!\n\nTarget is moving, buddy lasing isn't reliable in this situation!\n( Expect your laser missiles to miss! )", 20, nil, true):ToGroup(Client_Group) 
   
        elseif Target:GetVelocityKMH() == 0 then 
       
           MESSAGE:New("You're flying a Su-25T!\n\nTarget is static, buddy lasing should be reliable!", 20, nil, true):ToGroup(Client_Group) 
        end
     
     
     elseif Client_Group:GetTypeName() == "A-10A" then  
        
        MESSAGE:New("You're flying an A-10A!\n\nHUD diamond indicator only (AG mode)\n\nAGM-65E/L mavs and laser guided bombs required for buddy lasing", 20, nil, true):ToGroup(Client_Group)
     
     elseif Client_Group:GetTypeName() == "Su-25" then
         
         MESSAGE:New("You're flying a Su25!\n\nHUD indicator only (AG mode)\nYour laser guided missiles will ignore buddy lasing!", 20, nil, true):ToGroup(Client_Group)
     end
    
    
    MESSAGE:New("JTAC is lasing target "..Target:GetName().."\n\nLaser frequency = "..Lasing_AFAC:GetLaserCode().."\n\nTarget Coordinates = "..Target_LLDDM_1..IsMoving.."\n\nRange (Km) = "..Target_Range_KM_Rounded_1..
    "\nRange (NM) = "..Target_Range_NM_Rounded_1.."\n\nTarget Elevation MSL (meters) = "..Target_Elevation_MSL_1_Meters_Rounded_1..
    "\nTarget Elevation MSL (feet) = "..Target_Elevation_MSL_Ft_Rounded_1, 30, nil, false):ToGroup(Client_Group)
   
    
   elseif Lasing_AFAC:IsLasing() ~= true then
    
    MESSAGE:New("JTAC isn't lasing right now!",10, nil, true):ToGroup(Client_Group)
   
   end
 
  elseif Lasing_AFAC:IsAlive() ~= true then 
   
    MESSAGE:New("JTAC isn't responding!",10, nil, true):ToGroup(Client_Group)
   
  end
end 
  
 
 local function Lase_Target(Target, Client_Group)
 
  
   if Client_Group:IsAlive() ~= nil and Lasing_AFAC:IsAlive() == true and Lasing_AFAC:IsLasing() == true then
    
      MESSAGE:New("JTAC is already lasing a target!\n\nWait for target kill or lasing task abort",10, nil, true):ToGroup(Client_Group)
   
   end
   
    --if Lasing_AFAC:IsAlive() == true and Target:GetVelocityKMH() > 0 then
    
   -- MESSAGE:New("Target is moving, can't lase!",10, nil, true):ToGroup(Client_Group)
   
    --end
 
  if Client_Group:IsAlive() ~= nil and Lasing_AFAC:IsAlive() == true and Lasing_AFAC:IsLasing() ~= true and Target:IsAlive() ~= nil then
   
    
    local Target_LLDDM = Target:GetCoordinate():ToStringLLDDM()
    
    local Target_Range_Meters = Client_Group:GetPointVec3():Get3DDistance(Target:GetCoordinate())
    local Target_Range_KM = Target_Range_Meters / 1000
    local Target_Range_KM_Rounded = UTILS.Round(Target_Range_KM, 2)
    
    local Target_Range_NM = Target_Range_Meters / 1852
    local Target_Range_NM_Rounded = UTILS.Round(Target_Range_NM, 2)
    
    local Target_Elevation_MSL_Meters = land.getHeight(Target:GetVec2())
    local Target_Elevation_MSL_Meters_Rounded = UTILS.Round(Target_Elevation_MSL_Meters, 0)
    
    local Target_Elevation_MSL_Ft = Target_Elevation_MSL_Meters_Rounded * 3.281
    local Target_Elevation_MSL_Ft_Rounded = UTILS.Round(Target_Elevation_MSL_Ft, 0)
 
     if Client_Group:GetTypeName() == "Su-25T" then
     
         Lasing_AFAC:LaseUnit(Target, 1113, (Lasing_Time * 60)) 
         
        
        if Target:GetVelocityKMH() > 0 then 
    
         MESSAGE:New("You're flying a Su-25T!\n\nTarget is moving, buddy lasing isn't reliable in this situation!\n( Expect your laser missiles to miss! )", 20, nil, true):ToGroup(Client_Group) -- Russian laser missiles don't track buddy lasing spots properly when targets are moving 
   
        elseif Target:GetVelocityKMH() == 0 then -- Buddy lasing is allowed for non-moving targets
       
         MESSAGE:New("You're flying a Su-25T!\n\nTarget is static, buddy lasing should be reliable!", 20, nil, true):ToGroup(Client_Group) -- Buddy lasing works well will non-moving targets 
   
        end
     
     
     elseif Client_Group:GetTypeName() == "A-10A" then  
      
        -- Although the A-10A doesn't carry laser mavs, this will still put a "lasing diamond" on the HUD (when in AG mode), pretty handy stuff
      
         Lasing_AFAC:LaseUnit(Target, 1113, (Lasing_Time * 60))  
         
      
         MESSAGE:New("You're flying an A-10A!\n\nHUD diamond indicator only (AG mode)\n\nAGM-65E/L mavs and laser guided bombs required for buddy lasing", 20, nil, true):ToGroup(Client_Group)
      
      
     elseif Client_Group:GetTypeName() == "Su-25" then
       
         -- As for the Su25, its missiles will ignore buddy lasing spots, sadly, but this will still put the buddy lasing reticle on the analog HUD (when in AG mode). Not terribly useful, but useful enough 
       
         Lasing_AFAC:LaseUnit(Target, 1113, (Lasing_Time * 60)) 
         
        
         MESSAGE:New("You're flying a Su25!\n\nHUD indicator only (AG mode)\nYour laser guided missiles will ignore buddy lasing!", 20, nil, true):ToGroup(Client_Group)
     
     
     elseif Client_Group:GetTypeName() ~= "Su-25T" and Client_Group:GetTypeName() ~= "A-10A" and Client_Group:GetTypeName() ~= "Su-25" then
     
          Lasing_AFAC:LaseUnit(Target, Custom_LaserCode, (Lasing_Time * 60))
     end
     
     if Client_Group:IsAlive() ~= nil and Lasing_AFAC:IsAlive() == true and Lasing_AFAC:IsLasing() == true and Target:IsAlive() ~= nil then
     
       local Laser_Code = Lasing_AFAC:GetLaserCode()
       
       if Target:GetVelocityKMH() > 0 then
      
         IsMoving = "\n\nTarget is moving! (Marked with smoke)"
         
         Target:SmokeBlue()
      
       elseif  Target:GetVelocityKMH() == 0 then
    
         IsMoving = "\n\nTarget isn't moving! (Marked with smoke)"
         
         Target:SmokeBlue()
       end
    
       MESSAGE:New("JTAC is lasing target "..Target:GetName().."\n\nTarget Coordinates = "..Target_LLDDM.."\n\nLaser frequency = "..Laser_Code..IsMoving..
       "\n\nRange (Km) = "..Target_Range_KM_Rounded.."\nRange (NM) = "..Target_Range_NM_Rounded.."\n\nTarget Elevation MSL (meters) = "..Target_Elevation_MSL_Meters_Rounded..
       "\nTarget Elevation MSL (feet) = "..Target_Elevation_MSL_Ft_Rounded.."\n\nLasing will be active for "..Lasing_Time..
       " minutes!\n\n** Lasing Check & Abort Menu now available **", 30, nil, false):ToGroup(Client_Group)
      
       StatusMenuRoot = MENU_GROUP:New(Client_Group,"Lasing Check & Abort Menu")
       Status_Menu = MENU_GROUP_COMMAND:New(Client_Group, "Check Lasing Status", StatusMenuRoot, LaseCheck, Target, Client_Group)
       Abort_Menu = MENU_GROUP_COMMAND:New(Client_Group, "Abort Lasing", StatusMenuRoot, LaseAbort, Client_Group)
     
     end 
    
     if TargetMenuRoot then
        TargetMenuRoot:Remove()
     end
    
   elseif Client_Group:IsAlive() ~= nil and Lasing_AFAC:IsAlive() ~= true then
    
    MESSAGE:New("JTAC isn't responding!",10, nil, true):ToGroup(Client_Group)
   
   end
   
  Target:HandleEvent(EVENTS.Dead)
  
  function Target:OnEventDead(EventData)
 
   if EventData.initiator == Target:GetDCSObject() and Client_Group:IsAlive() ~= nil then
   
     Lasing_AFAC:LaseOff()
  
     MESSAGE:New(EventData.initiator:getName().." has been destroyed!\n\nLaser cooling down, lasing will be available again in a few seconds!", 10 ,nil , true):ToGroup(Client_Group)
   
     if TargetMenuRoot then
      TargetMenuRoot:Remove()
     end
     
     if StatusMenuRoot then
      StatusMenuRoot:Remove()
     end
   end
  end
 end
 
 
 local function Target_Picture(Client_Group)
  
  if Lasing_AFAC:IsAlive() == true  then
  
  local Lasing_Zone = ZONE_UNIT:New("AFAC_Lasing_Zone", Lasing_AFAC, Maximum_Detection_Range) 
  
  local TargetSET = SET_UNIT:New():FilterActive(Active):FilterPrefixes(Target_Prefixes):FilterStart()
  
   TargetSET:ForEachUnit(
   function(Target)
   
    if Client_Group:IsAlive() ~= nil and Target:IsInZone(Lasing_Zone) and Lasing_AFAC:IsDetected(Target) then
     
      MESSAGE:New("Detected targets added to Designation Menu", 10, nil, true):ToGroup(Client_Group)
     
      TargetMenuRoot = MENU_GROUP:New(Client_Group,"Target Designation Menu")
      MENU_GROUP_COMMAND:New(Client_Group, "Lase "..Target:GetName(), TargetMenuRoot, Lase_Target, Target, Client_Group)
      
    end
   end
   )
   
   if Client_Group:IsAlive() ~= nil and TargetSET:IsNotInZone(Lasing_Zone) == true then
   
    MESSAGE:New("No targets detected within lasing range!",10):ToGroup(Client_Group)
    
   end
  end 
   
     Client_Group:HandleEvent(EVENTS.Crash)

    function Client_Group:OnEventCrash(EventData)
 
     if EventData.initiator:getGroup() == Client_Group:GetDCSObject() then
   
      Lasing_AFAC:LaseOff()
     
      MESSAGE:New(EventData.initiator:getName().." has been destroyed!\n\nLaser cooling down, lasing will be available again in a few seconds!", 10, nil, true):ToAll()
   
     end
     
     if TargetMenuRoot then
      TargetMenuRoot:Remove()
     end
     
     if StatusMenuRoot then
      StatusMenuRoot:Remove()
     end
   
  end
 end 


local Birth_Event_Handler_MOOSE = EVENTHANDLER:New()

Birth_Event_Handler_MOOSE:HandleEvent(EVENTS.Birth)

function Birth_Event_Handler_MOOSE:OnEventBirth(EventData)

  
   _SETTINGS:SetPlayerMenuOff()
     
   -- MESSAGE:New("Event birth detected! (MOOSE method)", 10):ToAll()
       
       if EventData.initiator:getCategory() == Object.Category.UNIT and EventData.IniUnit:GetPlayerName() ~= nil then
        
        local unit = EventData.IniUnit
        local playerName = unit:GetPlayerName()
        
        local unitType = unit:GetTypeName()
        local Client_Group = unit:GetGroup()
    
    
    if Lasing_AFAC:IsAlive() == true and Lasing_AFAC:GetCoalition() == unit:GetCoalition() then
       
       MESSAGE:New("Player " .. playerName .. " has entered " .. unitType .. "\n\nJTAC F10 menu available!", 10, nil, true):ToGroup(Client_Group)
       --MESSAGE:New("Picture_Requested == 0",10):ToAll()
    
     AFACMenuRoot = MENU_GROUP:New(Client_Group,"JTAC Scan Menu")
     PictureCommand = MENU_GROUP_COMMAND:New(Client_Group, "Scan For Targets (within set range)", AFACMenuRoot, Target_Picture, Client_Group)
    
    elseif Lasing_AFAC:IsAlive() ~= true and AFACMenuRoot then
  
     AFACMenuRoot:Remove()
      
    end
  end 
end
  
  Lasing_AFAC:HandleEvent(EVENTS.Hit)
  
  function Lasing_AFAC:OnEventHit(EventData)
 
   if EventData.TgtDCSUnit == Lasing_AFAC:GetDCSObject() and Lasing_AFAC:GetLife0() > Lasing_AFAC:GetLife() then
   
    MESSAGE:New("JTAC has been hit!", 10):ToAll()
   
   end
  end
     
     Lasing_AFAC:HandleEvent(EVENTS.Crash)

    function Lasing_AFAC:OnEventCrash(EventData)
 
     if EventData.initiator == Lasing_AFAC:GetDCSObject() then
   
      if Lasing_AFAC:IsLasing() == true then
       Lasing_AFAC:LaseOff()
      end
  
       MESSAGE:New("JTAC has been destroyed!",10):ToAll()
     
       Picture_Requested = 0
     
       if TargetMenuRoot then
        TargetMenuRoot:Remove()
       end
     
       if StatusMenuRoot then
        StatusMenuRoot:Remove()
       end
     
       if AFACMenuRoot then
        AFACMenuRoot:Remove()
       end
     
     end 
   end